import { useContext } from 'react';
import invariant from 'tiny-invariant';
import { AppContext } from '../App/AppContext';
import { ModalContext } from './ModalContext';
const initialModal = {
    key: '',
    params: {},
    path: '',
    pathname: '',
    remove: () => { },
    state: undefined
};
export function useModal() {
    const app = useContext(AppContext);
    const modal = useContext(ModalContext);
    invariant(!!app, `You should not use useModal outside a <AppContext>`);
    invariant(!!modal, `You should not use useModal outside a <ModalContext>`);
    const setState = value => {
        if (app && modal) {
            if (typeof value === 'function') {
                app.modals.setLocationState(modal.key, value(modal.state));
            }
            else {
                app.modals.setLocationState(modal.key, value);
            }
        }
    };
    return [modal || initialModal, setState];
}
