import Animated from 'react-native-reanimated';
import { IRouter } from '../Router';
export interface IAnimationHandler {
    navigate: Animated.Value<number>;
    currentIndex: Animated.Value<number>;
    nextIndex: Animated.Value<number>;
    width: Animated.Value<number>;
    position: Animated.Adaptable<number>;
    isRTL: Animated.Value<0 | 1>;
    handleBackGesture: Animated.Node<any>;
    handleBackGestureEvent: (...args: any[]) => void;
    handleForwardGestureEvent: (...args: any[]) => void;
    handleNavigateTransitionStart: Animated.Node<any>;
}
export declare function createAnimationHandlers(router: IRouter, isRTLValue: boolean): IAnimationHandler;
