import Animated from 'react-native-reanimated';
import { findMatchingRoutes as baseFindMatchingRoutes } from '../../Router/utils';
const { Value } = Animated;
export function findMatchingRoutes(router, routes, prevRoutes, enableForwardRoutes) {
    const nextRoutes = baseFindMatchingRoutes(router.entries, routes, prevRoutes);
    return nextRoutes.map(route => {
        if (route.indexValue) {
            if (route.prevIndex !== route.index) {
                route.prevIndex = route.index;
                route.indexValue.setValue(route.index);
            }
            return route;
        }
        else {
            return {
                ...route,
                indexValue: new Value(route.index),
                prevIndex: route.index
            };
        }
    });
}
