import React, { useEffect, useState } from 'react';
import { RouterEventType } from './index';
import { useRouter } from './useRouter';
export const LocationContext = React.createContext(undefined);
export const LocationProvider = ({ location: l, children, match, route }) => {
    const router = useRouter();
    const [location, setLocation] = useState(() => {
        const { Component, path, ...rest } = route;
        return {
            ...router.entries.find(entry => entry.key === l.key),
            ...match,
            ...rest
        };
    });
    useEffect(() => {
        return router.addEventListener(RouterEventType.LocationStateChange, ({ key, state }) => {
            if (key === location.key) {
                const { Component, path, ...rest } = route;
                setLocation({
                    ...router.entries.find(entry => entry.key === l.key),
                    ...match,
                    ...rest,
                    state
                });
            }
        });
    }, []);
    return <LocationContext.Provider value={location} children={children}/>;
};
