export const createLocation = (path, state, key) => {
    let location;
    if (typeof path === 'string') {
        // Two-arg form: push(path, state)
        location = { pathname: path };
        location.state = state;
    }
    else {
        // One-arg form: push(location)
        location = { ...path };
        if (location.pathname === undefined)
            location.pathname = '';
        if (state !== undefined && location.state === undefined) {
            location.state = state;
        }
        if (location.state === undefined) {
            location.state = undefined;
        }
    }
    try {
        location.pathname = decodeURI(location.pathname);
    }
    catch (e) {
        if (e instanceof URIError) {
            throw new URIError('Pathname "' +
                location.pathname +
                '" could not be decoded. ' +
                'This is likely caused by an invalid percent-encoding.');
        }
        else {
            throw e;
        }
    }
    if (key)
        location.key = key;
    return location;
};
