import { useContext } from 'react';
import invariant from 'tiny-invariant';
import { AppContext } from '../App/AppContext';
import { createRouter } from './createRouter';
import { RouterContext } from './RouterContext';
export function useRouter(key) {
    if (key) {
        const app = useContext(AppContext);
        invariant(!!app, `You should not use useRouter outside a <AppContainer>`);
        if (app && app.routers[key]) {
            return app.routers[key];
        }
    }
    else {
        const router = useContext(RouterContext);
        invariant(!!router, `You should not use useRouter outside a <RouterContext>`);
        if (router) {
            return router;
        }
    }
    return createRouter();
}
