import { ILocation, IMatch, IRoute } from '../Router';
/**
 * Public API for matching a URL pathname to a path.
 */
export declare function matchPath<Params extends {
    [K in keyof Params]?: string;
}>(pathname: string, options: string | IRoute): IMatch<any> | null | undefined;
export declare type MatchingRoute = {
    location: ILocation;
    route: IRoute;
    match: IMatch<any>;
    index: number;
};
export declare function findMatchingRoute(location: ILocation, routes: IRoute[], index: number): MatchingRoute | null | undefined;
export declare function findMatchingRoutes<MatchedRoute extends MatchingRoute>(entries: ILocation[], routes: IRoute[], prevMatchingRoutes?: MatchedRoute[]): MatchedRoute[];
